/*
 * mm.c
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * ꡼ץ
 *
 * ǡΡ
 * 	ǡ̾phis_link
 * 	ؿlinkPhysPage()
 * 	unlinkPhysPage()
 * 	allocKernelPage()
 * 	allocUserPage()
 *		phis_linkξ֤ǥڡ꡼¾ץ鲣ꤵΤǡڡơ֥륨ȥ꡼ѹ
 * 		phis_linkäPHYS_PAGEǤpage_tbl_addƱɬפ롣
 */


#include"types.h"
#include"config.h"
#include"lib.h"
#include"lock.h"
#include"interrupt.h"
#include"proc.h"
#include"mp.h"
#include"segment.h"
#include"errno.h"
#include"fs.h"
#include"device.h"
#include"mm.h"
/****************************/
extern void test_program();
/*****************************/


static int buckupPage(void*);


/***********************************************************************************
 *
 * ʪ꡼饹
 *
 ***********************************************************************************/

/*
 * ʪ꡼ơ֥빽¤
 * Page
 */
typedef struct PHYS_PAGE{
	short ref_count;			/* reference count */
	ushort heap_num;			/* Heap number */
	PROC *proc;					/* ƤƤץ */
	struct PHYS_PAGE *next;
	struct PHYS_PAGE *prev;
}PHYS_PAGE;


/*
 * PRIVATE
 * ꡼ơ֥
 * freeTop (kernel mem)  (user mem) freeEnd
 * usedTop (new kernel mem)  (old kernel mem)  (new user mem)  (old user mem) usedEnd
 */
static PHYS_PAGE freeTop={0,0,NULL,NULL,NULL};		/* ʪ꡼󥯥ȥå */
static PHYS_PAGE freeEnd={0,0,NULL,NULL,NULL};		/* ʪ꡼󥯥 */
static PHYS_PAGE usedTop={0,0,NULL,NULL,NULL};		/* ʲġʪ꡼󥯥ȥå */
static PHYS_PAGE usedEnd={0,0,NULL,NULL,NULL};		/* ʲġʪ꡼󥯥 */
static PHYS_PAGE *usedUsrNew=NULL;					/* Υ桼ʪ꡼ */
static int physPageGate=0;							/* PHYS_PAGE lock gate */

/*
 * PRIVATE
 * ꡼setup.S
 */
uint all_memory_size;


/*
 * PUBLIC
 * Physical addressPHYS_PAGE address֤
 * parameters : Physical address
 * return : PHYS_PAGE address
 */
extern inline PHYS_PAGE *getPhyspageFromAddr(void *addr)
{
	return (PHYS_PAGE*)((uint)addr/PAGE_SIZE*sizeof(PHYS_PAGE)+PHYSICAL_PAGE_TABLE_ADD);
}


/*
 * PUBLIC
 * PHYS_PAGE addressPhysical addres֤
 * parameters : PHYS_PAGE address
 * return : Physical address
 */
extern inline void *getAddrFromPhyspage(PHYS_PAGE *memtable)
{
	return (void*)(((uint)memtable-PHYSICAL_PAGE_TABLE_ADD)/sizeof(PHYS_PAGE)*PAGE_SIZE);
}


/*
 * PUBLIC
 * ɥ쥹ڡơ֥륨ȥ꡼ɥ쥹롣
 * parameters : ɥ쥹
 * return : ڡɥ쥹
 */
extern inline uint *getPageAddr(uint addr,uint *page_dir)
{
	uint *page_tbl;


	page_tbl=(uint*)(page_dir[addr>>22]&0xfffff000);
	return &page_tbl[(addr>>12)&0x3ff];
}


/*
 * PUBLIC
 * ʪ꡼ڡλȥȤ䤹
 * parameters : ʪɥ쥹
 */
static void linkPhysPage(uint addr)
{
	PHYS_PAGE *p;


	p=getPhyspageFromAddr((void*)addr);

	enter_spinlock(&physPageGate);
	{
		if(++p->ref_count==1)
		{
			/* used link˲ä롣 */
			if(addr<KERNEL_DATA_END)
			{
				p->prev=&usedTop;
				p->next=usedTop.next;
				usedTop.next=p;
				p->next->prev=p;
			}
			else
			{
				p->prev=usedUsrNew->prev;
				p->next=usedUsrNew;
				usedUsrNew->prev=p;
				p->prev->next=p;
				usedUsrNew=p;
			}

			p->proc=get_current_task();
		}
		else if(p->ref_count==2)
		{
			/* Used link */
			p->prev->next=p->next;
			p->next->prev=p->prev;
			if(usedUsrNew==p)usedUsrNew=p->next;

			p->proc=NULL;
		}
	}
	exit_spinlock(&physPageGate);
}


/*
 * PUBLIC
 * ȥȤ򸺤餷ʪ꡼ڡ롣
 * parameters : ʪɥ쥹,ԡ饤ȥե饰
 * return : 0 or 1=ԡ饤ȤǻȲѤ餺
 */
static int unlinkPhysPage(uint addr,int cow_flag)
{
	int rest=0;
	PHYS_PAGE *p;


	p=getPhyspageFromAddr((void*)addr);

	enter_spinlock(&physPageGate);
	{
		/* ˻ȤƤʤޤϳԲĤΥڡ */
		if(--p->ref_count<0)
			p->ref_count=0;
		else if(p->ref_count==0)
		{
			if(cow_flag==1)
			{
				/* used link˲ä롣 */
				if(addr<KERNEL_DATA_END)
				{
					p->prev=&usedTop;
					p->next=usedTop.next;
					usedTop.next=p;
					p->next->prev=p;
				}
				else
				{
					p->prev=usedUsrNew->prev;
					p->next=usedUsrNew;
					usedUsrNew->prev=p;
					p->prev->next=p;
					usedUsrNew=p;
				}

				p->proc=get_current_task();
				p->ref_count=1;

				rest=1;
			}
			else
			{
				/* Used link */
				p->prev->next=p->next;
				p->next->prev=p->prev;
				if(usedUsrNew==p)usedUsrNew=p->next;

				if(addr<KERNEL_DATA_END)
				{
					p->next=freeTop.next;
					p->prev=&freeTop;
					freeTop.next=p;
					p->next->prev=p;
				}
				else
				{
					p->prev=freeEnd.prev;
					p->next=&freeEnd;
					freeEnd.prev=p;
					p->prev->next=p;
				}

				p->heap_num=0;
				p->proc=NULL;
			}
		}
	}
	exit_spinlock(&physPageGate);

	return rest;
}


/*
 * PUBLIC
 * ֤ͥʪڡƤ롣
 * ƤڡϲԲ
 * return : Allocate addres or NULL
 */
static void *allocKernelPage()
{
	void *address=NULL;
	bool used=0;
	PHYS_PAGE *p;


	enter_spinlock(&physPageGate);
	{
		p=freeTop.next;
		if((p!=&freeEnd)&((address=getAddrFromPhyspage(p))<(void*)KERNEL_DATA_END))
		{
			p->ref_count=1;
			freeTop.next=p->next;
			p->next->prev=&freeTop;
		}
		else if(((p=usedTop.next)!=&usedEnd)&(usedUsrNew!=p))
		{
			address=getAddrFromPhyspage(p);
			usedTop.next=p->next;
			p->next->prev=&usedTop;
			used=1;
		}
	}
	exit_spinlock(&physPageGate);

	/* ꡼ƤХååפ롣 */
	if(used&&(buckupPage(address)==-1))return NULL;

	return address;
}


/*
 * PUBLIC
 * 桼֤ʪڡƤ롣
 * Ƥڡϲ
 * parameters : ڡơ֥륢ɥ쥹
 * return : Allocate addres or error=NULL
 */
static void *allocUserPage(uint *page_tbl)
{
	void *addr=NULL;
	PHYS_PAGE *p;


	for(;;)
	{
		if((p=freeEnd.prev)!=&freeTop)
		{
			enter_spinlock(&physPageGate);

			if(p==freeEnd.prev)
			{
				addr=(void*)getAddrFromPhyspage(p);
				p->ref_count=1;

				/* ե꡼󥯤 */
				freeEnd.prev=p->prev;
				p->prev->next=&freeEnd;

				/* 󥯤˲ä롣 */
				if(addr<(void*)KERNEL_DATA_END)
				{
					p->prev=&usedTop;
					p->next=usedTop.next;
					usedTop.next=p;
					p->next->prev=p;
				}
				else
				{
					p->prev=usedUsrNew->prev;
					p->next=usedUsrNew;
					usedUsrNew->prev=p;
					p->prev->next=p;
					usedUsrNew=p;
				}

				p->proc=get_current_task();

				exit_spinlock(&physPageGate);

				break;
			}

			exit_spinlock(&physPageGate);
		}
		else if((p=usedEnd.prev)!=&usedTop)
		{
			enter_spinlock(&p->proc->pagedir_gate);
			enter_spinlock(&physPageGate);

			if(p==usedEnd.prev)
			{
				/* 󥯤 */
				addr=(void*)getAddrFromPhyspage(p);
				usedEnd.prev=p->prev;
				p->prev->next=&usedEnd;
				if(usedUsrNew==p)usedUsrNew=&usedEnd;

				exit_spinlock(&physPageGate);

				/* ꡼Ƥback up */
				if(buckupPage(addr)==-1)return NULL;

				exit_spinlock(&p->proc->pagedir_gate);

				break;
			}

			exit_spinlock(&physPageGate);
			exit_spinlock(&p->proc->pagedir_gate);
		}
		else break;
	}

	return addr;
}


/*
 * PUBLIC
 * ʪ꡼ơ֥롣
 */
static void initPhysicalPageTable()
{
	int i,last;
	PHYS_PAGE *p=(PHYS_PAGE*)PHYSICAL_PAGE_TABLE_ADD;


	/* ǽ1Mbyteʬ꡼Ƥ0ˡ */
	memset(p,0,0x100000/PAGE_SIZE*sizeof(PHYS_PAGE));

	/* Ĥե꡼ꤹ롣 */
	for(i=0x100000/PAGE_SIZE,last=all_memory_size/PAGE_SIZE;i<last;++i)
	{
		p[i].ref_count=0;
		p[i].heap_num=0;
		p[i].proc=NULL;
		p[i].next=&p[i+1];
		p[i].prev=&p[i-1];
	}
	freeTop.next=&p[0x100000/PAGE_SIZE];
	freeEnd.prev=&p[i-1];
	p[0x100000/PAGE_SIZE].prev=&freeTop;
	p[i-1].next=&freeEnd;

	/* ꡼ơ֥ʬ꡼ƤʲԲġˡ */
	last=ROUNDUP(PHYSICAL_PAGE_TABLE_ADD+all_memory_size/PAGE_SIZE*sizeof(PHYS_PAGE),PAGE_SIZE)/PAGE_SIZE;
	if(&p[PHYSICAL_PAGE_TABLE_ADD/PAGE_SIZE]==freeTop.next)
		freeTop.next=&p[last];
	else p[PHYSICAL_PAGE_TABLE_ADD/PAGE_SIZE-1].next=&p[last];

	/* Used link롣 */
	usedTop.next=&usedEnd;
	usedEnd.prev=&usedTop;
	usedUsrNew=&usedEnd;
}


/*
 * PUBLIC
 * Find size of all physical memory
 */
static uint findAllMemsize()
{
	enum{EXIST_MEM_SIZE=0x800000};		/* ꡼¬ñ */

	uint volatile *point;


	/* ꡼ñ̤Ȥ¬ꤹ*/
	for(point=(uint*)EXIST_MEM_SIZE-1;;point+=EXIST_MEM_SIZE/sizeof(uint))
	{
		*point=0x5a5a5a5a;
		if(*point!=0x5a5a5a5a)break;
		else
		{
			*point=0xf0f0f0f0;
			if(*point!=0xf0f0f0f0)break;
		}
	}

	return (all_memory_size=(uint)point-EXIST_MEM_SIZE+sizeof(uint));
}


/***********************************************************************************
 *
 * ꡼ȥ饹
 *
 ***********************************************************************************/

enum{
	HEAP_NUM=11,				/* kmallocMEM¤κ */
};


typedef struct FREE{
	char* last;
	struct FREE *prev;
	struct FREE *next;
}FREE;

typedef struct{
	uint size;
	FREE *free;
	int gate;
}HEAP;


/* kfreeʼ */
static FREE guard[HEAP_NUM];

/*
 * PRIVATE
 * kmallocѹ¤
 */
static HEAP heap[]={
	{0,NULL,0},
	{0x8,   &guard[1], 0},
	{0x10,  &guard[2], 0},
	{0x20,  &guard[3], 0},
	{0x40,  &guard[4], 0},
	{0x80,  &guard[5], 0},
	{0x100, &guard[6], 0},
	{0x200, &guard[7], 0},
	{0x400, &guard[8], 0},
	{0x800, &guard[9], 0},
	{0x1000,&guard[10],0}
};


/*
 * GLOBAL
 * 2Ѿ襵Ȥ˥ڡ꡼ʬ䤹
 * ϥڡ
 * parameters : Size by byte
 * return : address
 */
void *kmalloc(size_t size)
{
	char *addr=NULL;
	int i;


	if((size==0)||(size>PAGE_SIZE))return NULL;		/* Require size is over */

	for(i=1;size>heap[i].size;++i);					/* Require size=heap[i].size */

	enter_spinlock(&heap[i].gate);
	{
		if(heap[i].free==&guard[i])
		{
			if((heap[i].free=(FREE*)allocKernelPage())==NULL)goto OUT;

			/*
			 * Ȥaddress狼褦ˤ
			 */
			getPhyspageFromAddr((void*)heap[i].free)->heap_num=i;

			heap[i].free->prev=&guard[i];
			heap[i].free->next=&guard[i];
			guard[i].prev=heap[i].free;
			guard[i].next=heap[i].free;
			heap[i].free->last=(char*)heap[i].free+PAGE_SIZE;
		}

		addr=(char*)heap[i].free->last-heap[i].size;

		if(heap[i].free==(FREE*)addr)
		{
			heap[i].free=((FREE*)addr)->next;
			((FREE*)addr)->prev->next=((FREE*)addr)->next;
			((FREE*)addr)->next->prev=((FREE*)addr)->prev;
		}
		else heap[i].free->last=addr;
	}
OUT:
	exit_spinlock(&heap[i].gate);

	return addr;
}


/*
 * GLOBAL
 * ꡼
 * parameters : Address
 */
void kfree(void *ptr)
{
	uint i;
	FREE *p,*end;


	if(ptr==NULL)return;

	if((i=(int)getPhyspageFromAddr(ptr)->heap_num)==0)return;

	enter_spinlock(&heap[i].gate);
	{
		/* Free linkϾ */
		for(p=heap[i].free;p!=&guard[i];p=p->next)
			if(p>(FREE*)ptr)break;

		/* Link */
		p->prev->next=(FREE*)ptr;
		((FREE*)ptr)->prev=p->prev;
		((FREE*)ptr)->next=p;
		((FREE*)ptr)->last=(char*)ptr+heap[i].size;
		p->prev=(FREE*)ptr;

		/* ɥ쥹³ƤХ꡼Ĥʤ */
		end=((FREE*)ptr)->prev;
		do
		{
			p=p->prev;

			if(p->last==(char*)p->next)
			{
				p->last=p->next->last;
				p->next=p->next->next;
			}

			/* ꡼PAGE_SIZEʤڡ */
			if(!((uint)p&(PAGE_SIZE-1))&&(p->last>=(char*)p+PAGE_SIZE))
			{
				if(p->last>(char*)p+PAGE_SIZE)
				{
					p->prev->next=(FREE*)((char*)p+PAGE_SIZE);
					p->prev->next->next=p->next;
					p->prev->next->prev=p->prev;
					p->prev->next->last=p->last;
					p->next->prev=p->prev->next;
				}
				else
				{
					p->prev->next=p->next;
					p->next->prev=p->prev;
				}
				unlinkPhysPage((uint)p,0);

				break;
			}

		}while(p!=end);

		/* Free memory link Ƭ */
		heap[i].free=guard[i].next;
	}
	exit_spinlock(&heap[i].gate);
}


/***********************************************************************************
 *
 * ڡ󥰴ؿ
 *
 * ڡȤξ
 * ȥȤǤ뤳
 *
 ***********************************************************************************/

enum{
	PT_COPY_ON_WRITE=0x200,					/* ڡơ֥륨ȥ꡼Υԡ饤ȥե饰 */
	PT_TYPE_PAGING=0x9b,					/* ڡХååץǥХѡƥֹʲ */
	EMPTY_PB_SIZE=PAGE_SIZE/sizeof(uint),
	EMPTY_PB_START_SECTER=2					/* Ѳĥϥǥå */
};

typedef struct{
	int next;					/* index */
	int gate;					/* ԥå */
	uint index[EMPTY_PB_SIZE];
}PAGE_BACKUP;


/*
 * PRIVATE
 * ڡХåå׶ΰ襤ǥå
 */
static PAGE_BACKUP pageBackup={0,0};

/* PRIVATE */
static int pbDin;

/* PRIVATE */
static int pbSecters;

/* PRIVATE */
static uchar *pbCount[PAGE_BACKUP_SIZE_MAX/(PAGE_SIZE*PAGE_SIZE)];


/*
 * PUBLIC
 * ڡХååѥǥХΥޥȡ
 * parameters : device path
 * return : 0 or error=-1
 */
static int mountPageBackupDev(const char *dev_path)
{
	int fd;
	int din;
	DEV_STAT dev_stat;
	uint i,j,last,index;


	/* Device open */
	if((fd=sys_open(dev_path,0))==-1)return -1;
	if((din=get_inode(fd))==-1)return -1;
	pbDin=din;

	/* ѡƥ󥿥פγǧ */
	if(get_dev_stat(din,&dev_stat)==-1)return -1;
	if(dev_stat.prt_type!=PT_TYPE_PAGING)return -1;

	/* ڡХååפꡣ */
	pbSecters=PAGE_SIZE/dev_stat.sect_size;
	last=dev_stat.all_sect;
	if(last>PAGE_BACKUP_SIZE_MAX/pbSecters+EMPTY_PB_START_SECTER)
		last=PAGE_BACKUP_SIZE_MAX/pbSecters+EMPTY_PB_START_SECTER;
	index=pbSecters*(EMPTY_PB_SIZE-1)+EMPTY_PB_START_SECTER;
	j=0;
	for(i=index+pbSecters;i<last;i+=pbSecters)
	{
		pageBackup.index[j++]=i;

		if(j>=EMPTY_PB_SIZE)
		{
			j=0;
			if(write_direct(din,pageBackup.index,pbSecters,index)!=pbSecters)return -1;
			index=i;

			/* ʹԾɽ */
			printk("Mount page backup device %d%%\r",i/(last/100));
		}
	}
	pageBackup.index[j]=0;
	if(write_direct(din,pageBackup.index,pbSecters,index)!=pbSecters)return -1;

	/* ʹԾɽ */
	printk("Mount page backup device 100%%\n");

	/* ǽΥڡХååץǥåꡣ */
	i=EMPTY_PB_START_SECTER;
	for(j=0;j<EMPTY_PB_SIZE;++j)
	{
		if(i>=last)
		{
			pageBackup.index[j]=0;
			break;
		}
		pageBackup.index[j]=i;
		i+=pbSecters;
	}

	/* ȥơ֥ν */
	last=(last*dev_stat.sect_size+(PAGE_SIZE*PAGE_SIZE)-1)/(PAGE_SIZE*PAGE_SIZE);
	for(i=0;i<last;++i)
	{
		if((pbCount[i]=(uchar*)allocKernelPage())==NULL)return -1;
		memset(pbCount[i],0,PAGE_SIZE);
	}

	return 0;
}


/*
 * PRIVATE
 * ڡХååפ롣
 * return : ֥å or error=-1
 */
static int getEmptyBp()
{
	int blk;


	enter_spinlock(&pageBackup.gate);
	{
		if((blk=pageBackup.index[pageBackup.next])==0)return -1;		/* ֥åʤ */

		if(pageBackup.next++==EMPTY_PB_SIZE)
		{
			if(read_cache(pbDin,pageBackup.index,pbSecters,blk)!=pbSecters)return -1;
			pageBackup.next=0;
		}
	}
	exit_spinlock(&pageBackup.gate);

	return blk;
}


/*
 * PRIVATE
 * ڡХååפɲä롣
 * parameters : ڡХååץ֥å
 * return : 0 or error=-1
 */
static int addEmptyBp(int blk)
{
	enter_spinlock(&pageBackup.gate);
	{
		if(--pageBackup.next<0)
		{
			if(write_cache(pbDin,pageBackup.index,pbSecters,blk)!=pbSecters)return -1;
			pageBackup.next=EMPTY_PB_SIZE;
		}

		pageBackup.index[pageBackup.next]=blk;
	}
	exit_spinlock(&pageBackup.gate);

	return 0;
}


/*
 * PUBLIC
 * ڡХååץǥХλȲ1䤹
 * parameters : block number
 */
static void incrementPbCount(uint block)
{
	int tmp=pbSecters*PAGE_SIZE;


	block-=EMPTY_PB_START_SECTER;
	++pbCount[block/tmp][(block%tmp)/pbSecters];
}


/*
 * PARIVATE
 * ڡХååץǥХλȲ1餹
 * parameters : block number
 */
static void decrementPbCount(uint block)
{
	int tmp=pbSecters*PAGE_SIZE;


	block-=EMPTY_PB_START_SECTER;
	if(--pbCount[block/tmp][(block%tmp)/pbSecters]==0)
		addEmptyBp(block);
}


/*
 * PARIVATE
 * Buck up used page into page store device
 * parameters : physical address
 * returns : 0 or Error number
 */
static int buckupPage(void *addr)
{
	PROC *proc;
	uint *page_entry;
	int blk;


	proc=getPhyspageFromAddr(addr)->proc;
	page_entry=getPageAddr((uint)addr,proc->pagedir);

	/* page tableԺߤ */
	*page_entry&=~PAGE_PRESEN;

	/* process¹ʤpage tableTBLեå夹 */
	if((proc->cpu!=get_current_cpu())&&(cputask[proc->cpu].current_task==proc))
		issue_interrupt_to_cpu(proc->cpu,FLASH_PAGEDIR_VECT);

	/* Store page */
	if((blk=getEmptyBp())==0)goto ERR;
	if(write_cache(pbDin,addr,pbSecters,blk)!=pbSecters)goto ERR;
	incrementPbCount(blk);
	*page_entry=blk;

	return 0;

ERR:
	*page_entry|=PAGE_PRESEN;

	return -1;
}


/*
 * PRIVATE
 * ڡХååץǥХ꡼˽᤹
 * parmeters : memory buffer,device block
 * return : 0 or error=-1
 */
static int restorePage(void *buf,uint blk)
{
	/* ǥХɤ߹ߡ */
	if(read_cache(pbDin,buf,pbSecters,blk)!=pbSecters)return -1;

	/* ȥ󥿤򸺤餹 */
	decrementPbCount(blk);

	return 0;
}


/******************************** ̤ ***********************************************
 *
 * Set pagetable
 * parameters : Load page address,Sorce page address,Page flag,Load process
 * return : 0 or Error number
 *
int load_user_page(void *dist,int flag,PROC *proc)
{
	void *page;
	uint *pagetable;


	enter_spinlock(&proc->pagedir_gate);
	{
		pagetable=(uint*)proc->pagedir[(uint)dist/PAGEDIR_SIZE];

	    if(pagetable==0)
	    {
	    	***page tableƤ
	    	if((pagetable=(uint*)allocKernelPage())==NULL)goto ERROR;
	    	memset(pagetable,0,PAGE_SIZE);
	    	proc->pagedir[(uint)dist/PAGEDIR_SIZE]=(uint)pagetable|PAGE_PRESEN|PAGE_USER|PAGE_RW;
	    }
	    else pagetable=(uint*)((uint)pagetable&PAGE_ROUNDDOWN);

		****pageƤ
		if((page=allocUserPage(&pagetable[((uint)dist&(PAGEDIR_SIZE-1))/PAGE_SIZE]))==NULL)goto ERROR;
		pagetable[((uint)dist&(PAGEDIR_SIZE-1))/PAGE_SIZE]=(uint)page|PAGE_PRESEN|PAGE_USER|flag;
	}
	exit_spinlock(&proc->pagedir_gate);

	return 0;

ERROR:
	exit_spinlock(&proc->pagedir_gate);

	return -ENOMEM;
}


 *
 * page table
 * text sectionstackʳdata section롣user stack1pageĤƳ롣
 * parameters : process
 *
void free_user_page(PROC *proc)
{
	uint *page;
	int i,j;


	enter_spinlock(&proc->pagedir_gate);
	{
		***user stackκǽpageĤƳ
		page=(uint*)(proc->pagedir[USER_STACK_BEG/PAGEDIR_SIZE]&PAGE_ROUNDDOWN);
	    for(j=0;j<PAGE_SIZE/sizeof(uint)-1;++j)
	    {
	    	if(page[j]==0)continue;
	    	else if(page[j]&PAGE_PRESEN)
	    		unlinkPhysPage((void*)page[j]);
			else
			{
				if(--page_store_ref_table[page[j]>>1]==0)
					clear_page_store_use(page[j]>>1);
			}

			page[j]=0;
		}

		***Ĥuser page򤹤٤Ƴ
		for(i=USER_BEG/PAGEDIR_SIZE;i<USER_STACK_BEG/PAGEDIR_SIZE;++i)
	    	if(proc->pagedir[i]&PAGE_PRESEN)
	    	{
	    		page=(uint*)(proc->pagedir[i]&PAGE_ROUNDDOWN);
	    		for(j=0;j<PAGE_SIZE/sizeof(uint);++j)
	    		{
	    			if(page[j]==0)continue;
	    			else if(page[j]&PAGE_PRESEN)unlinkPhysPage((void*)page[j]);
					else
					{
						if(--page_store_ref_table[page[j]>>1]==0)
							clear_page_store_use(page[j]>>1);
					}
				}

				***page table
				unlinkPhysPage(page);

				***page direstory0ꥢ
				proc->pagedir[i]=0;
			}
	}
	exit_spinlock(&proc->pagedir_gate);
}
*****************************************************************************************************/

/*
 * GLOBAL
 * ڡե㳰
 * parameters : page fault address,Exception frame
 */
void pageFault(uint fault_addr,EXCEPT_FRAME frame)
{
	/* 顼ɥӥåȥޥ */
	enum{
		PRESEN=1,
		RW_MODE=2,
		USER_MODE=4,
		RSVBIT=8,
	};

	void *alloc_page;
	uint *current_page;
	uint *page_dir;
	int array;


	/* øڡȿ */
	if(((fault_addr<KERNEL_END)||(fault_addr>IOMAP_BEG))&&(frame.error&USER_MODE))
	{
		printk("Page privilege violation!\n");
		goto ERR;
	}

	current_page=getPageAddr(fault_addr,get_current_task()->pagedir);

	/* ڡԺߡ */
	if((frame.error&PRESEN)==0);
	{
		/* ʪڡγơ */
		if((alloc_page=allocUserPage(current_page))==NULL)
		{
			printk("Fail alloc physical page!\n ");
			goto ERR;
		}

		/* Хååפꡣ */
		if(*current_page!=0)
			if(restorePage(alloc_page,*current_page)==-1)
			{
				printk("Fail restore page!\n ");
				goto ERR;
			}

		*current_page|=(uint)alloc_page|PAGE_PRESEN|PAGE_RW|PAGE_USER;

		return;
	}

	if((frame.error&RW_MODE)==RW_MODE)
	{
		/* ԡ饤Ƚ */
		if(*current_page&PT_COPY_ON_WRITE)
		{
			page_dir=get_current_task()->pagedir;

			if(unlinkPhysPage(*current_page&~(PAGE_SIZE-1),1)==1)
			{
				*current_page=(*current_page&~PT_COPY_ON_WRITE)|PAGE_RW;
				page_dir[fault_addr/PAGEDIR_SIZE]&=~PT_COPY_ON_WRITE;

				return;
			}

			/*
			 * ڡǥ쥯ȥꥨȥ꡼˥ԡ饤ȥե饰ꤵƤϡ
			 * ڡơ֥Ƥ롣
			 */
			if(page_dir[fault_addr/PAGEDIR_SIZE]&PT_COPY_ON_WRITE)
			{
				array=fault_addr/PAGEDIR_SIZE;

				if((alloc_page=allocKernelPage())==NULL)
				{
					printk("Fail alloc physical page!\n ");
					goto ERR;
				}
				memcpy(alloc_page,(void*)(page_dir[array]&~(PAGE_SIZE-1)),PAGE_SIZE);
				page_dir[array]=((page_dir[array]&(PAGE_SIZE-1))|(uint)alloc_page)&~PT_COPY_ON_WRITE;
			}

			/* ʪڡγơ */
			if((alloc_page=allocUserPage(current_page))==NULL)
			{
				printk("Fail alloc physical page!\n ");
				goto ERR;
			}

			/* ڡƤƤڡ˥ԡ롣 */
			memcpy(alloc_page,(void*)(*current_page&~(PAGE_SIZE-1)),PAGE_SIZE);

			*current_page=(uint)alloc_page|PAGE_PRESEN|PAGE_RW|PAGE_USER;
		}

		/* 񤭹߰ȿ */
		else
		{
			printk("Page writing violation!\n ");
			goto ERR;
		}

		return;
	}

	/* ޤϲǽΥ顼 */
	printk("Can not recover page fault!");
ERR:
	/* ץ */
/************************************************/
	cli();
	idle();
/************************************************/
}


/*
 * GLOBAL
 * ͥڡơ֥ꤹ
 * return : Page directory or NULL
 */
uint *initPaging()
{
	void *stack;
	uint *idle_pagedir,*pagetable;
	uint i;


	/* ͥڡǥ쥯ȥ */
	if((idle_pagedir=(uint*)allocKernelPage())==NULL)return NULL;
	memset(idle_pagedir,0,PAGE_SIZE);
	for(i=0;i<KERNEL_STACK_BEG/PAGEDIR_SIZE;++i)
		idle_pagedir[i]=i*PAGEDIR_SIZE|PAGE_PRESEN|PAGE_RW|PAGE_4M;

	/* ͥ륹åڡƤ */
	if((pagetable=(uint*)allocKernelPage())==NULL)return NULL;
	memset(pagetable,0,PAGE_SIZE);
	idle_pagedir[KERNEL_STACK_BEG/PAGEDIR_SIZE]=(uint)pagetable|PAGE_PRESEN|PAGE_RW;
	if((stack=allocKernelPage())==NULL)return NULL;
	pagetable[1023]=(uint)stack|PAGE_PRESEN|PAGE_RW;

	/* ꡼ޥåץIOڡѥǥ쥯ȥ */
	for(i=IOMAP_BEG/PAGEDIR_SIZE;i<1024;++i)
	   	idle_pagedir[i]=i*PAGEDIR_SIZE|PAGE_PRESEN|PAGE_RW|PAGE_4M|PAGE_CASH_DISABLE;

	/* ڡ󥰳 */
	asm volatile(
			"movl	%%eax,%%cr3\n"			/* Set page directory address */
			"movl	$0x10,%%eax\n"
			"movl	%%eax,%%cr4\n"			/* 4Mڡĥ */
			"movl	%%cr0,%%eax\n"
			"orl	$0x80010000,%%eax\n"	/* Enable paging,Enable wp(ѡХν񤭹ݸ) */
			"movl	%%eax,%%cr0\n"
			"jmp	1f\n"
		"1:"
		::"a"(idle_pagedir)
	);

	return idle_pagedir;
}


/*
 * GLOBAL
 * forkˤ꡼ƥȤ򥳥ԡ
 * parameters : Destination page directory,Return stack offset
 * return : New Page directory or NULL
 */
uint *forkPage(PROC *org_proc,void **stack)
{
	uint *page_dir,*page_table,*org_page_table;
	int i;


	/* ƤΥڡǥ쥯ȥҤ˥ԡ롣 */
	if((page_dir=(uint*)allocKernelPage())==NULL)return NULL;
	memcpy(page_dir,org_proc->pagedir,PAGE_SIZE);

	/* ͥ륹åƤ롣 */
	if((page_table=(uint*)allocKernelPage())==NULL)goto ERR;

	page_dir[KERNEL_STACK_BEG/PAGEDIR_SIZE]=(uint)page_table|PAGE_PRESEN|PAGE_RW;
	org_page_table=(uint*)(org_proc->pagedir[KERNEL_STACK_BEG/PAGEDIR_SIZE]&~(PAGE_SIZE-1));
	if((*stack=allocKernelPage())==NULL)goto ERR;
	memcpy(*stack,(void*)(org_page_table[1023]&~(PAGE_SIZE-1)),PAGE_SIZE);
	page_table[1023]=(uint)*stack|PAGE_PRESEN|PAGE_RW;
	memset(page_table,0,1023*sizeof(uint));

	/*
	 * Userΰ򥳥ԡ饤Ȥꤹ롣
	 * ƤΥڡơ֥륨ȥ꡼񤭹߲Ĥʤ顢񤭹ԲĤˤƥԡ饤ȥե饰ꤹ롣
	 * ҤΥڡǥ쥯ȥꥨȥ꡼˥ԡ饤ȥե饰ꤹ롣
	 */
	enter_spinlock(&org_proc->pagedir_gate);
	{
		for(i=USER_BEG/PAGEDIR_SIZE;i<USER_END/PAGEDIR_SIZE;++i)
			if(page_dir[i]!=0)
			{
				org_page_table=(uint*)(page_dir[i]&~(PAGE_SIZE-1));
				for(i=0;i<PAGE_SIZE/sizeof(uint);++i)
				{
					if(org_page_table[i]==0)continue;
					else if((org_page_table[i]&PAGE_PRESEN)==0)		/* Хåå */
						incrementPbCount(org_page_table[i]);
					else if(org_page_table[i]&PAGE_RW)
					{
						org_page_table[i]=(org_page_table[i]&~PAGE_RW)|PT_COPY_ON_WRITE;
						linkPhysPage(org_page_table[i]&~(PAGE_SIZE-1));
					}
				}

				page_dir[i]|=PT_COPY_ON_WRITE;
			}
	}
	exit_spinlock(&org_proc->pagedir_gate);

	return page_dir;

ERR:
	unlinkPhysPage((uint)page_dir,0);

	return NULL;
}


/*
 * GLOBAL
 * get physical address from linear address
 * parameters : linear address
 * return : physical address
 */
void *getPhysAddrFromLinearAddr(void *liner_addr)
{
	return (void*)(*getPageAddr((uint)liner_addr,get_current_task()->pagedir)&~(PAGE_SIZE-1));
}


/***********************************************************************************
 *
 * ؿ
 *
 ***********************************************************************************/

/*
 * GLOBAL
 * ꡼ƥν
 */
void initMm()
{
	/* Find size of physical memory  */
	printk("Memory size = %d MB\n",findAllMemsize()/0x100000);

	/* ʪ꡼ơ֥ */
	initPhysicalPageTable();

	/* ڡѵΰν */
/*	int mountPageBackupDev();*/
}
